/* command.c
 *
 * functions used by server to communicate with client
 */

#include "net3d.h"

int stillalive;

/* wait until all clients have signalled that they are ready, then
 * return.
 *
 * note - this function is now obsolete!
 */
void waitforclients(int psocks[], int plcount)
{
fd_set read_fds;			/* file descriptors to wait on */
int i;					/* loop counter */
bool gotmsg[MAX_PLAYERS];		/* got message yet? */
int got=0;				/* messages so far got */

/* intially, no messages have been received */
for(i=0; i<plcount; i++)
	gotmsg[i]=false;

while(got != plcount) {
	/* wait on the file descriptors of clients from whom there
	 * has been no message so far.
	 */
	FD_ZERO(&read_fds);
	for(i=0; i<plcount; i++)
		if (!gotmsg[i])
			FD_SET(psocks[i],&read_fds);

	/* block until a message is received from a client, then mark
	 * that client as ready, and increase the number ready.
	 */
#ifdef __hpux
	select(getdtablesize(),(int *)&read_fds,NULL,NULL,NULL);
#else
	select(getdtablesize(),&read_fds,NULL,NULL,NULL);
#endif
	for(i=0; i<plcount; i++)
		if (FD_ISSET(psocks[i],&read_fds)) {
			gotmsg[i]=true;
			got++;
			}
	}
}


/* Read a line from each client, and re-transmit them to all clients
 */
void processnet(int psocks[], int plcount, int mainsock)
{
char clcom[400];			/* message to send to clients */
char *msg;				/* message from client */
static Bool dead[MAX_PLAYERS] = {0};	/* list of who's dead */
int i;					/* loop counter */

/* start broadcast with game time, followed by concatenation of 
 * messages from clients.
 */
sprintf(clcom,"%f",gametime());
for(i=0; i<plcount; i++) {
	msg=ngets(psocks[i]);
#if NETDEBUG
		printf("recieved \"%s\" from player %d\n",msg,i);
#endif
	if (msg[0] == 'd' && !dead[i]) {
		/* client has declared that it's player is dead.
		 */
		dead[i] = True;
		stillalive--;
		if (stillalive==1) {
			/* Tell all clients that only one player is left. */ 
			strcat(clcom," w 0 0.0");
			printf("we have a winner..\n");
			}
		}
	else {
		if (strlen(msg)) {
			strcat(clcom," ");
			strcat(clcom,msg);
			}
		}
	}

/* send broadcast message to all clients */
#if NETDEBUG
	printf("sending \"%s\" to clients\n",clcom);
#endif

for(i=0; i<plcount; i++)
	nprintf(psocks[i],"%s\n",clcom);
}

